-- @since 1.4
-- search string and limit returned characters
-- %1$d - MaxDisplayContentSize
-- %2$d - AdjustedDisplayOffset
SELECT
    A.NOTE_ID AS ID,
    A.FIELD,
    A.OFFSET - 1 AS OFFSET,
    A.VALUE,
    CASE WHEN locate('|', ImageIndex.INDEX) > 0 THEN
        cast(substr(ImageIndex.INDEX, 1, locate('|', ImageIndex.INDEX)-1) as varchar(32672))
    ELSE
        cast(ImageIndex.INDEX as varchar(32672))
    END as IMAGE_SRC,
    -- Used when field is Content.
    -- >0 if returned value is not at the beginning of doc
    A.VALUE_START_POS
FROM
(
    -- Note search index
    SELECT
        A.NOTE_ID,
        A.FIELD,
        A.OFFSET,
        CASE WHEN A.FIELD = 'Content' THEN
            -- doc content
            CASE WHEN A.OFFSET > 24/*REPLACE:24 WITH:%2$d*/ AND LENGTH(A.VALUE) > 192/*REPLACE:192 WITH:%1$d*/ THEN
                CASE WHEN (A.OFFSET-1 - 24/*REPLACE:24 WITH:%2$d*/) > (LENGTH(A.VALUE) - 192/*REPLACE:192 WITH:%1$d*/) THEN
                  '...' || CAST(SUBSTR(A.VALUE, LENGTH(A.VALUE)+4 - 192/*REPLACE:192 WITH:%1$d*/) AS VARCHAR(192/*REPLACE:192 WITH:%1$d*/))
                ELSE
                  '...' || CAST(SUBSTR(A.VALUE, A.OFFSET -24/*REPLACE:24 WITH:%2$d*/) AS VARCHAR(192/*REPLACE:192 WITH:%1$d*/))
                END
            ELSE
                CAST(A.VALUE AS VARCHAR(192/*REPLACE:192 WITH:%1$d*/))
            END
        ELSE
            CAST(NoteIndex.INDEX AS VARCHAR(192/*REPLACE:192 WITH:%1$d*/))
        END AS VALUE,
        CASE WHEN A.FIELD = 'Content' THEN
            -- doc content start position
            CASE WHEN A.OFFSET > 24/*REPLACE:24 WITH:%2$d*/ AND LENGTH(A.VALUE) > 192/*REPLACE:192 WITH:%1$d*/ THEN
                CASE WHEN (A.OFFSET-1 - 24/*REPLACE:24 WITH:%2$d*/) > (LENGTH(A.VALUE) -  192/*REPLACE:192 WITH:%1$d*/) THEN
                    LENGTH(A.VALUE) - 192/*REPLACE:192 WITH:%1$d*/
                ELSE
                    A.OFFSET-1 - 24/*REPLACE:24 WITH:%2$d*/- 3
                END
            ELSE
                0
            END
        ELSE
            0
        END AS VALUE_START_POS
    FROM (
        SELECT
            NoteIndex.NOTE_ID,
            NoteIndex.FIELD,
            locate('test'/*REPLACE:'test' WITH:?*/, lcase(NoteIndex.INDEX)) AS OFFSET,
            NoteIndex.INDEX AS VALUE
        FROM  GLOBONOTE.NoteSearchIndex as NoteIndex
        WHERE FIELD NOT IN ('ImageSource') -- exclude some fields in searching
    ) AS A
    INNER JOIN GLOBONOTE.NoteSearchIndex as NoteIndex
    ON A.NOTE_ID = NoteIndex.NOTE_ID AND NoteIndex.FIELD = 'Content'
    WHERE A.OFFSET > 0
    
    UNION
    
    -- Title Matching
    SELECT
        Note.ID AS NOTE_ID,
        'Title' AS FIELD,
        locate('test'/*REPLACE:'test' WITH:?*/, lcase(Note.TITLE)) AS OFFSET,
        CAST(NoteIndex.INDEX as VARCHAR(192/*REPLACE:192 WITH:%1$d*/)) as VALUE,
        0 as VALUE_START_POS
    FROM  GLOBONOTE.Note AS Note
    INNER JOIN  GLOBONOTE.NoteSearchIndex as NoteIndex
    ON Note.ID = NoteIndex.NOTE_ID AND NoteIndex.FIELD = 'Content'
) AS A
LEFT JOIN GLOBONOTE.NoteSearchIndex as ImageIndex
ON A.NOTE_ID = ImageIndex.NOTE_ID AND ImageIndex.FIELD = 'ImageSource'
WHERE A.OFFSET > 0